//------------------------------------------------------------------------------
//
// common.h
//
//------------------------------------------------------------------------------
#ifndef _COMMON_H_
#define _COMMON_H_

//windows
#include <windows.h>

//std
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

//DirectX
#include <d3d9.h>
#include <d3dx9.h>
#include <dsound.h>

#define DIRECTINPUT_VERSION    0x800
#include <dinput.h>


//COM
#define RELEASE(x)            { if( (x) ) { x->Release(); } x = NULL; }
#define SAFE_DELETE(x)        { if( (x) ) { delete     x; } x = NULL; }
#define SAFE_DELETE_ARRAY(x)  { if( (x) ) { delete []  x; } x = NULL; }

//RAD
#define RAD(x) D3DXToRadian(x)


POINT   GetMousePos();
DWORD   GetWidth();
DWORD   GetHeight();
BOOL    GetIsWindow();
HWND    GetWindowHandle();
HINSTANCE GetInstanceHandle();

HRESULT Init(LPSTR szName, DWORD w, DWORD h, BOOL bWindow);
HRESULT Term();
BOOL    DoEvent();
HRESULT BeginScene();
HRESULT EndScene();
HRESULT Flip();
HRESULT Clear(D3DCOLOR color);
HRESULT StartScene(D3DCOLOR color);

LPDIRECT3DDEVICE9 GetDevice();
LPSTR   DisplayDriverName();
LPSTR   DisplayDescriptionName();


#endif
